<?php
namespace Teknisa\CNC\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request;
use Teknisa\CNC\Services;
use Teknisa\CNC\Utilities;

class BandeiraCNC extends \Zeedhi\Framework\Controller\Simple {
    
    protected $entityManager;
    protected $bandeiraService;
    protected $salesMessage;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager, Services\BandeiraCNC $bandeiraService, Utilities\SalesMessageCNC $salesMessage) {
        $this->entityManager   = $entityManager;
        $this->bandeiraService = $bandeiraService;
        $this->salesMessage    = $salesMessage;
    }

    public function getFlags(Request\Filter $request, Response $response){
        try {
            $row = $request->getFilterCriteria()->getConditions();
            if ($row[0]["columnName"] == "NMBANDEIRA"){
                $Result = $this->bandeiraService->loadFlagByname($row);
            } else{
                $row["NRORG"] = $row[0]["value"];
                $row["LABELBANDEIRA"] = isset($row[1]["value"]) ? $row[1]["value"] : "%%";
                $Result = $this->bandeiraService->getFlags($row);
    
            }
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('BandeirasRepo', $Result));
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }
}