<?php
namespace Teknisa\CNC\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Notification;
use Teknisa\CNC\Services;
use Teknisa\CNC\Utilities;

class FilialCNC extends \Zeedhi\Framework\Controller\Simple {
    
    protected $filialService;
    protected $salesMessage;

    
    public function __construct(Services\FilialCNC $filialService, Utilities\SalesMessageCNC $salesMessage) {
        $this->filialService   = $filialService;
        $this->salesMessage    = $salesMessage;
    }

    public function getFiliaisAdq(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();

            $resultadoFiltrado = $this->filialService->getFiliaisAdq($params, $request);

            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('GetFiliaisAdqRepo', $resultadoFiltrado));
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }

    public function getFiliais(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();

            $filiais = $this->filialService->getFiliais($params, $request);

            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('GetFiliaisRepo', $filiais));
            
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }
}