<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class FilialCNCFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function getFiliaisFiltered($query){
        $sql = $query;
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFiliais($params){
        $sql = "SELECT DAT.CDFILIAL, DAT.NMFILIAL, DAT.CDFILIAL||' - '||DAT.NMFILIAL AS LABELFILIAL, N
                  FROM (
                    SELECT D.*, ROWNUM as N FROM (
                      SELECT CDFILIAL, NMFILIAL, CDFILIAL||' - '||NMFILIAL AS LABELFILIAL, NRORG
                        FROM FILIAL
                        WHERE UPPER (CDFILIAL||' - '||NMFILIAL) LIKE UPPER (:NMFILIAL)
                       UNION 
                        SELECT DISTINCT C.CDFILIAL, F.NMFILIAL, C.CDFILIAL||' - '||F.NMFILIAL AS LABELFILIAL, C.NRORG
                        FROM CONSMOVCAIXA C 
                         JOIN FILIAL F
                          ON C.CDFILIAL = F.CDFILIAL
                        WHERE UPPER (C.CDFILIAL||' - '||F.NMFILIAL) LIKE UPPER (:NMFILIAL)
                        AND IDORIGFOS = 'N'
                        ORDER BY LABELFILIAL
                      ) D
                    ) DAT
                  WHERE N BETWEEN :FIRST AND :LAST
                  AND DAT.NRORG = :NRORG
                  ORDER BY LABELFILIAL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getFiliaisFilteredAdq($query){
        $sql = $query;
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFiliaisAdq($params){
        $sql = "SELECT DISTINCT CDFILIAL, NMFILIAL, CDFILIAL||' - '||NMFILIAL AS LABELFILIAL, 'Não' PARAMETRIZADA
                 FROM ( SELECT DAT.CDFILIAL, DAT.NMFILIAL, DAT.CDFILIAL||' - '||DAT.NMFILIAL AS LABELFILIAL, N
                    FROM (
                            SELECT D.*, ROWNUM as N FROM (
                              SELECT CDFILIAL, NMFILIAL, CDFILIAL||' - '||NMFILIAL AS LABELFILIAL
                                FROM FILIAL
                                WHERE UPPER (CDFILIAL||' - '||NMFILIAL) LIKE UPPER (:LABELFILIAL)
                               UNION 
                                SELECT DISTINCT CDFILIALCON, NMFILIALCON, CDFILIALCON||' - '||NMFILIALCON AS LABELFILIAL
                                FROM CONSMOVCAIXA
                                WHERE UPPER (CDFILIALCON||' - '||NMFILIALCON) LIKE UPPER (:LABELFILIAL)
                                AND IDORIGFOS = 'N'
                              ) D
                            ) DAT
                          WHERE N BETWEEN :FIRST AND :LAST) F
                 WHERE NOT EXISTS (SELECT 1
                                     FROM VALIDACAOADQFIL V
                                    WHERE V.NRSEQADQ = :NRSEQADQ
                                      AND V.CDFILIALCON = F.CDFILIAL)
                UNION
                SELECT V.CDFILIALCON CDFILIAL, F.NMFILIAL, V.CDFILIALCON||' - '||F.NMFILIAL AS LABELFILIAL, 'Sim' PARAMETRIZADA
                 FROM VALIDACAOADQFIL V JOIN(
                                              SELECT DAT.CDFILIAL, DAT.NMFILIAL, DAT.CDFILIAL||' - '||DAT.NMFILIAL AS LABELFILIAL, N
                                              FROM (
                                                SELECT D.*, ROWNUM as N FROM (
                                                  SELECT CDFILIAL, NMFILIAL, CDFILIAL||' - '||NMFILIAL AS LABELFILIAL
                                                    FROM FILIAL
                                                    WHERE UPPER (CDFILIAL||' - '||NMFILIAL) LIKE UPPER (:LABELFILIAL)
                                                   UNION 
                                                    SELECT DISTINCT CDFILIALCON CDFILIAL, NMFILIALCON NMFILIAL, CDFILIALCON||' - '||NMFILIALCON AS LABELFILIAL
                                                    FROM CONSMOVCAIXA
                                                    WHERE UPPER (CDFILIALCON||' - '||NMFILIALCON) LIKE UPPER (:LABELFILIAL)
                                                    AND IDORIGFOS = 'N'
                                                    ORDER BY LABELFILIAL
                                                  ) D
                                                ) DAT
                                              WHERE N BETWEEN :FIRST AND :LAST
                                              ORDER BY LABELFILIAL
                                            ) F
                ON V.CDFILIALCON = F.CDFILIAL
                AND V.NRSEQADQ = :NRSEQADQ";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}
