<?php

namespace Teknisa\CNC\Services;

use Zeedhi\Framework\DTO\Request;
use Teknisa\CNC\Utilities;
use Teknisa\CNC\Factories;
use Teknisa\Libs\Util\Environment;

class FilialCNC {

	protected $entityManager;
	protected $util;
	protected $filialFactory;
    protected $environment;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Utilities\UtilCNC $util, Factories\FilialCNCFactory $filialFactory, Environment $environment)  {
		$this->entityManager = $entityManager;
		$this->util          = $util;
		$this->filialFactory = $filialFactory;
        $this->environment   = $environment;
	}

	public function getFiliaisAdq ($params, $request) {

	    $NRSEQUENCIAL = $params[0]['value'];            
        
        $ficaFrioAi= null;
        if(isset($params[1])){
            if(is_array($params[1]['value'])){
                $ficaFrioAi= true;
                $LABELFILIAL = $params[1]['value'];
                $paramsfilial = array(
                    ':LABELFILIAL' => $LABELFILIAL
                );
                $query = "SELECT DISTINCT CDFILIAL, NMFILIAL, CDFILIAL||' - '||NMFILIAL AS LABELFILIAL, 'Não' PARAMETRIZADA FROM (SELECT DAT.CDFILIAL, DAT.NMFILIAL, DAT.CDFILIAL||' - '||DAT.NMFILIAL AS LABELFILIAL, N FROM (SELECT D.*, ROWNUM as N FROM (SELECT CDFILIAL, NMFILIAL, CDFILIAL||' - '||NMFILIAL AS LABELFILIAL FROM FILIAL WHERE (INSTR (UPPER (:LABELFILIAL), UPPER (CDFILIAL||' - '||NMFILIAL)) > 0) UNION SELECT CDFILIALCON, NMFILIALCON, CDFILIALCON||' - '||NMFILIALCON AS LABELFILIAL FROM CONSMOVCAIXA WHERE (INSTR (UPPER (:LABELFILIAL), UPPER (CDFILIALCON||' - '||NMFILIALCON)) > 0) AND IDORIGFOS = 'N'ORDER BY LABELFILIAL ) D ) DAT ) F WHERE NOT EXISTS (SELECT 1 FROM VALIDACAOADQFIL V WHERE V.NRSEQADQ = :NRSEQADQ AND V.CDFILIALCON = F.CDFILIAL) UNION SELECT V.CDFILIALCON CDFILIAL, F.NMFILIAL, V.CDFILIALCON||' - '||F.NMFILIAL AS LABELFILIAL, 'Sim' PARAMETRIZADA FROM VALIDACAOADQFIL V JOIN(SELECT DAT.CDFILIAL, DAT.NMFILIAL, DAT.CDFILIAL||' - '||DAT.NMFILIAL AS LABELFILIAL, N FROM (SELECT D.*, ROWNUM as N FROM (SELECT CDFILIAL, NMFILIAL, CDFILIAL||' - '||NMFILIAL AS LABELFILIAL FROM FILIAL WHERE (INSTR (UPPER (:LABELFILIAL), UPPER (CDFILIAL||' - '||NMFILIAL)) > 0) UNION SELECT CDFILIALCON, NMFILIALCON, CDFILIALCON||' - '||NMFILIALCON AS LABELFILIAL FROM CONSMOVCAIXA WHERE (INSTR (UPPER (:LABELFILIAL), UPPER (CDFILIALCON||' - '||NMFILIALCON)) > 0) AND IDORIGFOS = 'N'ORDER BY LABELFILIAL ) D ) DAT ) F ON V.CDFILIALCON = F.CDFILIAL AND V.NRSEQADQ = :NRSEQADQ"; 
                foreach (array_keys($paramsfilial) as $index => $name) {
                    if(!empty($paramsfilial[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsfilial[$name]);
                        $paramsfilial[$name] = '';
                    }
                    else{
                        $paramsfilial[$name] = 'null';
                    }
                }
                $query = preg_replace('/'.':NRSEQADQ'.'/', $NRSEQUENCIAL, $query, 2);
                $resultadoFiltrado = $this->filialFactory->getFiliaisFilteredAdq($query);
                return $resultadoFiltrado;
            }
            $LABELFILIAL  = $params[1]['value'];
        }else{
            $ficaFrioAi= false;
            $LABELFILIAL = "%%";
        }
        if(!$ficaFrioAi){
            $page = $request->getFilterCriteria()->getPage();
            $pageSize = $request->getFilterCriteria()->getPageSize();
            $FIRST = $request->getFilterCriteria()->getPageSize() * ($page-1);
            $LAST = ($FIRST + $pageSize);
            if($page > 1){
                $FIRST++;
            }
			$params = array(
				':FIRST' 	   => $FIRST,
				':LAST' 	   => $LAST,
				':LABELFILIAL' => $LABELFILIAL,
				':NRSEQADQ'    => $NRSEQUENCIAL
			);

			$filial = $this->filialFactory->getFiliaisAdq($params);
			return $filial;
		}
	}

	public function getFiliais ($params, $request) {
        $ficaFrioAi= null;
        $NRORG = $this->environment->getNrOrgTrab();
        if(isset($params[0])){
            if(is_array($params[0]['value'])){
                $ficaFrioAi= true;
                $LABELFILIAL = $params[0]['value'];
                $paramsfilial = array(
                    ':NMFILIAL' => $LABELFILIAL
                );
                $query = "SELECT DAT.CDFILIAL, DAT.NMFILIAL, DAT.CDFILIAL||' - '||DAT.NMFILIAL AS LABELFILIAL, N FROM (SELECT D.*, ROWNUM as N FROM (SELECT CDFILIAL, NMFILIAL, CDFILIAL||' - '||NMFILIAL AS LABELFILIAL, NRORG FROM FILIAL WHERE UPPER (CDFILIAL||' - '||NMFILIAL) LIKE UPPER (:NMFILIAL) UNION SELECT DISTINCT C.CDFILIAL, F.NMFILIAL, C.CDFILIAL||' - '||F.NMFILIAL AS LABELFILIAL, NRORG FROM CONSMOVCAIXA C JOIN FILIAL F ON C.CDFILIAL = F.CDFILIAL WHERE UPPER (C.CDFILIAL||' - '||F.NMFILIAL) LIKE UPPER (:NMFILIAL) AND IDORIGFOS = 'N'ORDER BY LABELFILIAL ) D ) DAT WHERE N BETWEEN :FIRST AND :LAST AND DAT.NRORG = :NRORG ORDER BY LABELFILIAL"; 
                foreach (array_keys($paramsfilial) as $index => $name) {
                    if(!empty($paramsfilial[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsfilial[$name]);
                        $paramsfilial[$name] = '';
                    }
                    else{
                        $paramsfilial[$name] = 'null';
                    }
                }
                $query = preg_replace('/'.':NRORG'.'/', $NRORG, $query, 1);
                $resultadoFiltrado = $this->filialFactory->getFiliaisFiltered($query);
                return $resultadoFiltrado;
            }   
            $LABELFILIAL = $params[0]['value'];
        }else{
            $ficaFrioAi= false;
            $LABELFILIAL = "%%";
        }
        if(!$ficaFrioAi){
            $page = $request->getFilterCriteria()->getPage();
            $pageSize = $request->getFilterCriteria()->getPageSize();
            $FIRST = $request->getFilterCriteria()->getPageSize() * ($page-1);
            $LAST = ($FIRST + $pageSize);
            if($page > 1){
                $FIRST++;
            }
			$params = array(
				':FIRST' 	   => $FIRST,
				':LAST' 	   => $LAST,
				':NMFILIAL'    => $LABELFILIAL,
                ':NRORG'       => $NRORG
			);

			$filial = $this->filialFactory->getFiliais($params);
			return $filial;
		}
	}

}